# Changelog

This file tracks the changes introduced by gittuf versions.

## v0.3.0

* Added check to prevent duplicate RSL entries for the same ref and target
* Added a formal developer mode for new early-stage gittuf features
* Added early support for attestations with one type for approving reference
  changes (developer mode only)
* Added support for gittuf-specific Git hooks with a pre-push hook to fetch /
  create / push RSL entries
* Updated `verify-ref` to perform full verification by default (BREAKING CHANGE)
* Updated identification of trusted keys in policy to support varying threshold
  values between delegations
* Added verification tests for delegated policies
* Added root key management commands to the CLI
* Added command to list rules in gittuf policy
* Added support for standard encoding of private and public keys
* Added support for verifying SSH Git commit and tag signatures
* Added check for cycles when walking policy graph during verification
* Added autogenerated CLI docs
* Removed file rule verification when no file rules exist in the policy for
  efficiency
* Added command to sign existing policy file with no other changes
* Added get started guide and gittuf logo to docs
* Removed CLI usage message for gittuf errors
* Updated various dependencies

## v0.2.0

* Added support to RSL to find unskipped entries
* Added `Get*` functions to gitinterface to compartmentalize choice of Git
  library
* Added support in RSL and policy functions for RSL annotation entries
* Added recovery mode for policy verification workflow
* Added `go fmt` as Makefile target
* Updated length of refspecs slice to account for doubled entries
* Added support for merge commits in gitinterface
* Updated CLI to check if Git signing is viable to abort early
* Fixed bug in CLI that required an unnecessary signing key argument
* Fixed `clone`'s ability to handle trailing slashes
* Improved testing for in policy verification for delegations
* Added plumbing for better logging
* Updated various dependencies
* Updated installation instructions to include Sigstore verification of binaries

## v0.1.0

* Implemented reference state log (RSL)
* Added support for Git reference policies using RSL entry signatures
* Added support for file policies using commit signatures
* Added support for basic gittuf sync operations
